﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.9
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
		
	Private sqlRecent As SQL

	Private fileNameSel As String
	Private pathNameSel As String
	Private dbFileName As String
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	dbFileName = "RecentFilesCP.db"
	initRecentDatabase(File.DirRootExternal, dbFileName)
	
	fileNameSel = "dummyFileName"
	pathNameSel = "dummyPath"
	
	addOrUpdateFile(fileNameSel, pathNameSel, (pathNameSel & "\" & fileNameSel), "n", 1000)
	
End Sub

Sub Service_Start (StartingIntent As Intent)
'	Service.StopAutomaticForeground 'Starter service can start in the foreground state in some edge cases.
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub




'======================================================================================================
Sub checkRecentFilesDB(logOn As Boolean, setJournal As String, integrityCheck As Boolean, doFullCheckPoint As Boolean, setAutoCheckPoint As Int) As Boolean
	'Check the database
	Dim qryStr As String
	Dim qryOutList As List
	Dim row() As String
	
	If integrityCheck Then
		qryStr = "PRAGMA integrity_check;"
		qryOutList = ExecuteMemoryTable(sqlRecent, qryStr, Null, 2)
		row = qryOutList.Get(0)
		If row(0).CompareTo("ok") <> 0 Then
			If logOn Then Log("DB Integrity = BAD")
			Return False
		End If
	
		If logOn Then Log("DB Integrity = OK")
	End If
	
	
	If setJournal <> "" Then
		qryStr = "PRAGMA journal_mode=" &  setJournal & ";"
		qryOutList = ExecuteMemoryTable(sqlRecent, qryStr, Null, 2)
		row = qryOutList.Get(0)
		If row(0).CompareTo("wal") <> 0 Then
			If logOn Then Log("Set Journal Mode = " &  setJournal & " Mode = FAILED")
			Return False
		End If
		
		If logOn Then Log("Set Journal Mode = " &  setJournal & " Mode = OK")
	End If
	
	
	If doFullCheckPoint Then
		qryStr = "PRAGMA wal_checkpoint(PASSIVE);"
		qryOutList = ExecuteMemoryTable(sqlRecent, qryStr, Null, 2)
		row = qryOutList.Get(0)
		If row(0) < 0 Then
			If logOn Then Log("Checkpoint PASSIVE = Failed")
			Return False
		End If

		If logOn Then Log("Checkpoint PASSIVE = OK:  Busy = " & row(0) & "  Log = " & row(1) & "  Checkpointed = " & row(2))
	End If
	
	
	If setAutoCheckPoint <> -3 Then
		Select setAutoCheckPoint
			Case -1
				qryStr = "PRAGMA wal_autocheckpoint=-1;" 	'No checkpoint
			Case 0
				qryStr = "PRAGMA wal_autocheckpoint=1000;"  'sqLite Default
			Case Else
				qryStr = "PRAGMA wal_autocheckpoint=" & setAutoCheckPoint & ";" 'User setting
		End Select
			
		qryOutList = ExecuteMemoryTable(sqlRecent, qryStr, Null, 2)
		row = qryOutList.Get(0)
		If row(0) < 0 Then
			If logOn Then Log("DB Checkpoint Value Setting = Failed")
			Return False
		End If
		
		If logOn Then Log("DB Checkpoint Value Setting = OK")
	End If
	Return True
End Sub


''======================================================================================================
'Public Sub makeDataDirUnderAppDir(dirName As String) As String
'	'Get the App dir and check If this is the Objects directory - We don't want to put user files in here
'	Dim cwd As String = File.DirApp
'
'	Dim matcher1 As Matcher = Regex.Matcher("[^\\]+\\?$",cwd)
'	
'	Do While matcher1.Find
'		If matcher1.Match.ToLowerCase.CompareTo("objects") = 0 Then
'			cwd = Regex.Replace("[^\\]+\\?$", File.DirApp, "\Files")
'			Exit
'		End If
'	Loop
'	
'	'Check if new cwd Exists and create if neccessary
'	If File.IsDirectory (cwd,"") = False Then
'		File.MakeDir(cwd, "Files")
'	End If
'	
'	Return cwd
'End Sub


'======================================================================================================
private Sub initRecentDatabase(path As String, dbName As String) As Boolean

	If File.Exists(path, dbName) Then
		Try
			sqlRecent.Initialize(path, dbName, False)
			'   				  logOn, setJournal, integrityCheck, doFullCheckPoint, setAutoCheckPoint) As Boolean
			If checkRecentFilesDB(True,  "WAL",      True,           True,             -3) = False Then
				Return False
			End If
		Catch
		Log(LastException)
		Return False
		End Try
	Else
		Try
			sqlRecent.Initialize(path, dbName, True) '********************** ERROR 1 *************************
		Catch
			Log(LastException)
			Return False
		End Try
		
		Try
			'Create the recent files table
			'createRecentTable
			SQLInit
			'   				  logOn, setJournal, integrityCheck, doFullCheckPoint, setAutoCheckPoint) As Boolean
			If checkRecentFilesDB(True,  "WAL",      False,          False, 		   -3) = False Then
				Return False
			End If
		Catch
			Log(LastException)
			Return False
		End Try
	End If
	Return True
End Sub


'======================================================================================================
Public Sub RemoveRedundantSpace(TextToClean As String) As String
	Return Regex.Replace("[\s]{2,}", TextToClean, " ")
End Sub


'======================================================================================================
Private Sub createRecentTable
	
	Dim qryStr As String = _
	$"CREATE TABLE tblRecentFiles(
  		ID INTEGER, 
  		fileName TEXT, 
  		path TEXT, 
  		fullPath TEXT, 
  		dateFirstOpened DATETIME, 
  		dateLastOpened DATETIME, 
  		fileNotFound CHAR, 
  		fileSize LARGEINT, 
  	CONSTRAINT ID PRIMARY KEY(ID COLLATE BINARY))"$
	
	qryStr = RemoveRedundantSpace(qryStr)
	
	Try
		sqlRecent.ExecNonQuery(qryStr)
	Catch
		Log(LastException)
		Return
	End Try
End Sub


'======================================================================================================
'create the stocdatabase
Sub SQLInit
	Private query As String
	
	query = "CREATE TABLE Stock (Number INTEGER, ProductID INTEGER, Date INTEGER)"
	sqlRecent.ExecNonQuery(query)
'	query = "INSERT INTO Stock VALUES (5, 1, " & DateTime.Now & ")"
	query = "INSERT INTO Stock VALUES (5, 1, 1092941466000)"
	sqlRecent.ExecNonQuery(query)
	query = "INSERT INTO Stock VALUES (10, 2, 1265583600000)"
	sqlRecent.ExecNonQuery(query)
	query = "INSERT INTO Stock VALUES (15, 4, 1328655600000)"
	sqlRecent.ExecNonQuery(query)
	query = "INSERT INTO Stock VALUES (2, 5, 1297119600000)"
	sqlRecent.ExecNonQuery(query)
	query = "INSERT INTO Stock VALUES (20, 3, 1391814000000)"
	sqlRecent.ExecNonQuery(query)
	query = "INSERT INTO Stock VALUES (25, 6, " & DateTime.Now & ")"
	sqlRecent.ExecNonQuery(query)
	
	query = "CREATE TABLE Products (Name TEXT, Price REAL, SupplierID INTEGER)"
	sqlRecent.ExecNonQuery(query)
	query = "INSERT INTO Products VALUES ('Break', 350, 1)"
	sqlRecent.ExecNonQuery(query)
	query = "INSERT INTO Products VALUES ('Break', 175, 3)"
	sqlRecent.ExecNonQuery(query)
	query = "INSERT INTO Products VALUES ('Break', 250, 2)"
	sqlRecent.ExecNonQuery(query)
	query = "INSERT INTO Products VALUES ('Exhaust pipe', 150, 2)"
	sqlRecent.ExecNonQuery(query)
	query = "INSERT INTO Products VALUES ('Exhaust pipe', 250, 1)"
	sqlRecent.ExecNonQuery(query)
	query = "INSERT INTO Products VALUES ('Exhaust pipe', 175, 4)"
	sqlRecent.ExecNonQuery(query)
		
	query = "CREATE TABLE Suppliers (Name TEXT, Address TEXT, City TEXT)"
	sqlRecent.ExecNonQuery(query)
	query = "INSERT INTO Suppliers VALUES ('Renault','Rue de la Gare 30', 'Paris')"
	sqlRecent.ExecNonQuery(query)
	query = "INSERT INTO Suppliers VALUES ('Ford', 'Main street 11', 'Detroit')"
	sqlRecent.ExecNonQuery(query)
	query = "INSERT INTO Suppliers VALUES ('VW', 'Hauptstrasse 3', 'Wolfsburg')"
	sqlRecent.ExecNonQuery(query)
	query = "INSERT INTO Suppliers VALUES ('Toyota', 'Yokohama street 30', 'Tokyo')"
	sqlRecent.ExecNonQuery(query)
End Sub
'======================================================================================================
'Author: Erel
'Executes the query and returns the result as a list of arrays.  
'Each item in the list is a strings array.
'StringArgs - Values to replace question marks in the query. Pass Null if not needed.
'Limit - Limits the results. Pass 0 for all results.
Public Sub ExecuteMemoryTable(SQL As SQL, Query As String, StringArgs() As String, Limit As Int) As List
	Dim cur As ResultSet

	If StringArgs = Null Then
		Dim StringArgs(0) As String
	End If
	
	Try
		cur = SQL.ExecQuery2(Query, StringArgs)
	Catch
		Log(LastException)
	End Try
	
'	Log("ExecuteMemoryTable: " & Query)
	Dim table As List
	table.Initialize
	Do While cur.NextRow
		Dim values(cur.ColumnCount) As String
		For col = 0 To cur.ColumnCount - 1
			values(col) = cur.GetString2(col)
		Next
		table.Add(values)
		If Limit > 0 And table.Size >= Limit Then Exit
	Loop
	cur.Close
	Return table
End Sub


'======================================================================================================
Private Sub addOrUpdateFile(fileName As String, path As String, fullPath As String,  fileNotFound As Char, fileSize As Long) As Boolean
	'Check if full path exists
	Dim qryStr As String
	Dim dateStr As String
	DateTime.DateFormat = "yyyy-MM-dd"
	DateTime.TimeFormat = "HH:mm:ss"
	dateStr = DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now)
	
	qryStr = _
	$"SELECT COUNT(fullPath) FROM tblRecentFiles WHERE fullPath = ?"$
	
	Dim cur As ResultSet
	
	Try
		cur = sqlRecent.ExecQuery2(qryStr, Array As String(fullPath))
	Catch
		Log(LastException)
	End Try
	
	cur.NextRow
	If cur.GetLong2(0) = 0 Then
		qryStr = _
				$"INSERT INTO tblRecentFiles (
                  fileName,
                  path,
				  fullPath,
                  dateFirstOpened,
                  dateLastOpened,
				  fileNotFound,
				  fileSize)
                  VALUES (?,
                          ?,
                          ?,
                          ?,
                          ?,
						  ?,
						  ?)"$
						  
		sqlRecent.BeginTransaction
		Try
			sqlRecent.ExecNonQuery2(qryStr, Array As String(fileName, path, fullPath, dateStr, dateStr, fileNotFound, fileSize))
			Log("Recent File Added: " & fullPath &  "  Date: " & dateStr)
		Catch
			Log(LastException)
		End Try
		sqlRecent.TransactionSuccessful
		
	Else
		qryStr = _
				$"UPDATE tblRecentFiles 
					SET 
						dateLastOpened 	= ?, 
						fileNotFound 	= ?, 
						fileSize 		= ? 
					WHERE fullPath 		= ?"$
	
		sqlRecent.BeginTransaction
		Try
			sqlRecent.ExecNonQuery2(qryStr, Array As String(dateStr, fileNotFound, fileSize, fullPath))
			Log("Recent File Updated: " & fullPath &  "  Date: " & dateStr)
		Catch
			Log(LastException)
		End Try
		sqlRecent.TransactionSuccessful
		
	End If
	Return True
End Sub
